        CLS
        DEFLNG A-Z
        DIM nit$(51)

        TYPE imsg
            msgstat AS STRING * 1
            msgnum AS STRING * 4
            msgref AS STRING * 4
            msgblks AS STRING * 1
            msgdate AS STRING * 8
            msgtime AS STRING * 5
            msgto AS STRING * 25
            replydate AS STRING * 4
            replytime AS STRING * 5
            reply AS STRING * 1
            msgfrom AS STRING * 25
            msgsubject AS STRING * 25
            msgpasswd AS STRING * 12
            active AS STRING * 1
            msgecho AS STRING * 1
            spare AS STRING * 6
        END TYPE
        DIM imhdr AS imsg

        TYPE mhdr
            himsg AS STRING * 4
            lomsg AS STRING * 4
            activemsgs AS STRING * 4
            callers AS STRING * 4
            lockstat AS STRING * 6
            sparem AS STRING * 106
        END TYPE
        DIM mmhdr AS mhdr

        TYPE indx
            pointer AS STRING * 4
        END TYPE
        DIM ndx AS indx
             
        fil$ = "NITS"
        CALL exist(fil$, found%)
        IF found% = 0 THEN
            PRINT "NITS file missing!"
            CLOSE : END
        END IF
            
        OPEN fil$ FOR INPUT ACCESS READ LOCK WRITE AS #1
        nits = 1
        WHILE NOT EOF(1)
            LINE INPUT #1, nit$(nits)
            nit$(nits) = UCASE$(nit$(nits))
            nits = nits + 1
        WEND
        CLOSE 1
        nits = nits - 1

        fil$ = "MSGBASES"
        CALL exist(fil$, found%)
        IF found% = 0 THEN
            PRINT "MSGBASES file missing!"
            CLOSE : END
        END IF

        OPEN fil$ FOR INPUT ACCESS READ LOCK WRITE AS #3

getbase: ' get the next message base to process
        IF EOF(3) GOTO alldone
        LINE INPUT #3, msgbase$

        msgndx$ = msgbase$ + ".ndx"
              
        CALL exist(msgbase$, found%)
        IF found% = 0 THEN
            PRINT UCASE$(msgbase$); " file missing!"
            CLOSE : END
        END IF

        CALL exist(msgndx$, found%)
        IF found% = 0 THEN
            PRINT UCASE$(msgndx$); " file missing!"
            CLOSE : END
        END IF

        OPEN msgbase$ FOR RANDOM ACCESS READ WRITE LOCK READ WRITE AS #1 LEN = 128
        OPEN msgndx$ FOR RANDOM ACCESS READ WRITE LOCK READ WRITE AS #2 LEN = 4
               
        ' get & print the Message base header

        recno = 1: ndxno = 1
        GET #1, recno, mmhdr
        GOSUB MmhdrConvert
        GOSUB printmmhdr
    
getptr: ' get the index pointer to the message
        GET #2, ndxno, ndx
        pointer = CVSMBF(ndx.pointer)
        IF pointer <= 0 THEN
            ndxno = ndxno + 1
            GOTO getptr
        END IF

        ' get the individual message header      
        GET #1, pointer, imhdr

msgnum = CVSMBF(imhdr.msgnum)
       
        msgto$ = RTRIM$(imhdr.msgto)
        msgto$ = UCASE$(msgto$)
       
        msgfrom$ = RTRIM$(imhdr.msgfrom)
        msgfrom$ = UCASE$(msgfrom$)

        ' let's see if it's TO or FROM a NIT
        FOR t = 1 TO nits
            IF msgto$ = nit$(t) OR msgfrom$ = nit$(t) THEN
                PRINT "Deleted:"; msgfrom$, msgto$, msgnum
                imhdr.active = CHR$(226)
                PUT #1, pointer, imhdr
                pointer = pointer * -1
                ndx.pointer = MKSMBF$(pointer)
                PUT #2, ndxno, ndx
            END IF
        NEXT t

nxtmsg: IF msgnum = himsg GOTO nextbase
        ndxno = ndxno + 1
        GOTO getptr

nextbase:
        CLOSE 1: CLOSE 2
        GOTO getbase

alldone: ' close up & go away

        CLOSE 1: CLOSE 2: CLOSE 3
        END

MmhdrConvert:   REM convert the MMHDR data to numerics
        himsg = CVSMBF(mmhdr.himsg)
        lomsg = CVSMBF(mmhdr.lomsg)
        activemsgs = CVSMBF(mmhdr.activemsgs)
        callers = CVSMBF(mmhdr.callers)
        lockstat$ = mmhdr.lockstat
        sparem$ = mmhdr.sparem
       
        RETURN

printmmhdr:  ' print the Message base header - just to prove we can
        PRINT "Msg Base  :"; msgbase$
        PRINT "NDX file  :"; msgndx$
        PRINT "High Msg  :"; himsg
        PRINT "Lo Msg    :"; lomsg
        PRINT "Active Msg:"; activemsgs
        PRINT "Ttl Callrs:"; callers
        PRINT
       
        RETURN

